// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function ISINCheck(isin, errorMessage){
  var isValid;
  var numberReference;
  var checkDigitReference;
  var numberString;
  var digitReference;

  numberReference = {};
  checkDigitReference = {};
  numberString = [];
  numberString.length = 1;
  digitReference = {};

  if(isin.length == 12){
    arraysCopyStringRange(isin, 0, isin.length - 1, numberReference);

    isValid = ISINComputeCheckDigit(numberReference.string, checkDigitReference, errorMessage);
    if(isValid){
      if(checkDigitReference.characterValue == isin[isin.length - 1]){
      }else{
        numberString[0] = isin[isin.length - 1];
        isValid = nCreateNumberFromDecimalStringWithCheck(numberString, digitReference, errorMessage);
        if(isValid){
          errorMessage.string = "Check digit wrong.".split('');
        }else{
          errorMessage.string = "Check symbol not a digit.".split('');
        }
        isValid = false;
      }
    }
  }else{
    isValid = false;
    errorMessage.string = "Number is too short: must be at least one digit.".split('');
  }

  return isValid;
}
function ISINComputeCheckDigit(isin, checkDigitReference, errorMessage){
  var isValid;
  var isinNumericReference;

  isinNumericReference = {};

  if(isin.length == 11){
    isValid = ISINToNumericCode(isin, isinNumericReference, errorMessage);

    if(isValid){
      LuhnComputeCheckDigit(isinNumericReference.string, checkDigitReference, errorMessage);
    }
  }else{
    isValid = false;
    errorMessage.string = "ISIN must be 11 digits before the checksum digit to be calculated.".split('');
  }

  return isValid;
}
function ISINExtendWithCheckDigit(isin, extended, errorMessage){
  var isValid;
  var i;
  var checkDigitReference;

  checkDigitReference = {};
  isValid = ISINComputeCheckDigit(isin, checkDigitReference, errorMessage);

  if(isValid){
    extended.string = [];
    extended.string.length = isin.length + 1;
    for(i = 0; i < isin.length; i = i + 1){
      extended.string[i] = isin[i];
    }
    extended.string[i] = checkDigitReference.characterValue;
  }

  return isValid;
}
function ISINToNumericCode(isin, isinNumericReference, errorMessage){
  var isValid;
  var lengthx, i, pos;
  var code;

  isValid = true;
  code = {};

  lengthx = 0;

  for(i = 0; i < isin.length && isValid; i = i + 1){
    if(charIsLetter(isin[i])){
      lengthx = lengthx + 2;
    }else if(charIsNumber(isin[i])){
      lengthx = lengthx + 1;
    }else{
      isValid = false;
      errorMessage.string = "ISIN can only contain alpha-numeric characters.".split('');
    }
  }

  if(isValid){
    isinNumericReference.string = [];
    isinNumericReference.string.length = lengthx;

    pos = 0;

    for(i = 0; i < isin.length; i = i + 1){
      ISINSymbolToCode(isin[i], code, errorMessage);

      isinNumericReference.string[pos] = code.string[0];
      pos = pos + 1;
      if(code.string.length == 2){
        isinNumericReference.string[pos] = code.string[1];
        pos = pos + 1;
      }
    }
  }

  return isValid;
}
function ISINSymbolToCode(c, stringReference, errorMessage){
  var isValid;

  if(charIsLetter(c) && charIsUpperCase(c)){
    if(c == 'A'){
      stringReference.string = "10".split('');
    }else if(c == 'B'){
      stringReference.string = "11".split('');
    }else if(c == 'C'){
      stringReference.string = "12".split('');
    }else if(c == 'D'){
      stringReference.string = "13".split('');
    }else if(c == 'E'){
      stringReference.string = "14".split('');
    }else if(c == 'F'){
      stringReference.string = "15".split('');
    }else if(c == 'G'){
      stringReference.string = "16".split('');
    }else if(c == 'H'){
      stringReference.string = "17".split('');
    }else if(c == 'I'){
      stringReference.string = "18".split('');
    }else if(c == 'J'){
      stringReference.string = "19".split('');
    }else if(c == 'K'){
      stringReference.string = "20".split('');
    }else if(c == 'L'){
      stringReference.string = "21".split('');
    }else if(c == 'M'){
      stringReference.string = "22".split('');
    }else if(c == 'N'){
      stringReference.string = "23".split('');
    }else if(c == 'O'){
      stringReference.string = "24".split('');
    }else if(c == 'P'){
      stringReference.string = "25".split('');
    }else if(c == 'Q'){
      stringReference.string = "26".split('');
    }else if(c == 'R'){
      stringReference.string = "27".split('');
    }else if(c == 'S'){
      stringReference.string = "28".split('');
    }else if(c == 'T'){
      stringReference.string = "29".split('');
    }else if(c == 'U'){
      stringReference.string = "30".split('');
    }else if(c == 'V'){
      stringReference.string = "31".split('');
    }else if(c == 'W'){
      stringReference.string = "32".split('');
    }else if(c == 'X'){
      stringReference.string = "33".split('');
    }else if(c == 'Y'){
      stringReference.string = "34".split('');
    }else if(c == 'Z'){
      stringReference.string = "35".split('');
    }

    isValid = true;
  }else if(charIsNumber(c)){
    if(c == '0'){
      stringReference.string = "0".split('');
    }else if(c == '1'){
      stringReference.string = "1".split('');
    }else if(c == '2'){
      stringReference.string = "2".split('');
    }else if(c == '3'){
      stringReference.string = "3".split('');
    }else if(c == '4'){
      stringReference.string = "4".split('');
    }else if(c == '5'){
      stringReference.string = "5".split('');
    }else if(c == '6'){
      stringReference.string = "6".split('');
    }else if(c == '7'){
      stringReference.string = "7".split('');
    }else if(c == '8'){
      stringReference.string = "8".split('');
    }else if(c == '9'){
      stringReference.string = "9".split('');
    }

    isValid = true;
  }else{
    isValid = false;
    errorMessage.string = "Character is not an ISIN alpha-character.".split('');
  }

  return isValid;
}
function test(){
  var failures;
  var errorMessage, extended;

  errorMessage = {};
  extended = {};

  failures = 0;

  ISINCheck("US0378331005".split(''), errorMessage);

  ISINExtendWithCheckDigit("US037833100".split(''), extended, errorMessage);

  return failures;
}
function nCreateStringScientificNotationDecimalFromNumber(decimal){
  var mantissaReference, exponentReference;
  var multiplier, inc;
  var exponent;
  var done, isPositive;
  var result;
  mantissaReference = {};
  exponentReference = {};
  result = [];
  result.length = 0;
  done = false;
  exponent = 0;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }else{
    isPositive = true;
  }

  if(decimal == 0){
    done = true;
  }

  if( !done ){
    multiplier = 0;
    inc = 0;
    if(decimal < 1){
      multiplier = 10;
      inc =  -1;
    }else if(decimal >= 10){
      multiplier = 0.1;
      inc = 1;
    }else{
      done = true;
    }
    if( !done ){
      for(; decimal >= 10 || decimal < 1; ){
        decimal = decimal*multiplier;
        exponent = exponent + inc;
      }
    }
  }

  nCreateStringFromNumberWithCheck(decimal, 10, mantissaReference);

  nCreateStringFromNumberWithCheck(exponent, 10, exponentReference);

  if( !isPositive ){
    result = AppendString(result, "-".split(''));
  }

  result = AppendString(result, mantissaReference.string);
  result = AppendString(result, "e".split(''));
  result = AppendString(result, exponentReference.string);

  return result;
}
function nCreateStringDecimalFromNumber(decimal){
  var stringReference;
  stringReference = {};

  /* This will succeed because base = 10. */
  nCreateStringFromNumberWithCheck(decimal, 10, stringReference);

  return stringReference.string;
}
function nCreateStringFromNumberWithCheck(decimal, base, stringReference){
  var string;
  var maximumDigits;
  var digitPosition;
  var hasPrintedPoint, isPositive;
  var i, d;
  var success;
  var characterReference;
  var c;
  isPositive = true;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }

  if(decimal == 0){
    stringReference.string = "0".split('');
    success = true;
  }else{
    characterReference = {};
    if(IsInteger(base)){
      success = true;
      string = [];
      string.length = 0;
      maximumDigits = nGetMaximumDigitsForBase(base);
      digitPosition = nGetFirstDigitPosition(decimal, base);
      decimal = Math.round(decimal*Math.pow(base, maximumDigits - digitPosition - 1));
      hasPrintedPoint = false;
      if( !isPositive ){
        string = AppendCharacter(string, '-');
      }
      if(digitPosition < 0){
        string = AppendCharacter(string, '0');
        string = AppendCharacter(string, '.');
        hasPrintedPoint = true;
        for(i = 0; i <  -digitPosition - 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }
      }
      for(i = 0; i < maximumDigits && success; i = i + 1){
        d = Math.floor(decimal/Math.pow(base, maximumDigits - i - 1));
        if(d >= base){
          d = base - 1;
        }
        if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
          if(decimal != 0){
            string = AppendCharacter(string, '.');
          }
          hasPrintedPoint = true;
        }
        if(decimal == 0 && hasPrintedPoint){
        }else{
          success = nGetSingleDigitCharacterFromNumberWithCheck(d, base, characterReference);
          if(success){
            c = characterReference.characterValue;
            string = AppendCharacter(string, c);
          }
        }
        if(success){
          decimal = decimal - d*Math.pow(base, maximumDigits - i - 1);
        }
      }
      if(success){
        for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }
        stringReference.string = string;
      }
    }else{
      success = false;
    }
  }

  /* Done */
  return success;
}
function nGetMaximumDigitsForBase(base){
  var t;
  t = Math.pow(10, 15);
  return Math.floor(Math.log10(t)/Math.log10(base));
}
function nGetFirstDigitPosition(decimal, base){
  var power;
  var t;
  power = Math.ceil(Math.log10(decimal)/Math.log10(base));

  t = decimal*Math.pow(base,  -power);
  if(t < base && t >= 1){
  }else if(t >= base){
    power = power + 1;
  }else if(t < 1){
    power = power - 1;
  }

  return power;
}
function nGetSingleDigitCharacterFromNumberWithCheck(c, base, characterReference){
  var numberTable;
  var success;
  numberTable = nGetDigitCharacterTable();

  if(c < base || c < numberTable.length){
    success = true;
    characterReference.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function nGetDigitCharacterTable(){
  var numberTable;
  numberTable = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".split('');

  return numberTable;
}
function nCreateNumberFromDecimalStringWithCheck(string, decimalReference, errorMessage){
  return nCreateNumberFromStringWithCheck(string, 10, decimalReference, errorMessage);
}
function nCreateNumberFromDecimalString(string){
  var doubleReference;
  var stringReference;
  var number;
  doubleReference = CreateNumberReference(0);
  stringReference = CreateStringReference("".split(''));
  nCreateNumberFromStringWithCheck(string, 10, doubleReference, stringReference);
  number = doubleReference.numberValue;

  delete(doubleReference);
  delete(stringReference);

  return number;
}
function nCreateNumberFromStringWithCheck(string, base, numberReference, errorMessage){
  var success;
  var numberIsPositive, exponentIsPositive;
  var beforePoint, afterPoint, exponent;
  numberIsPositive = CreateBooleanReference(true);
  exponentIsPositive = CreateBooleanReference(true);
  beforePoint = {};
  afterPoint = {};
  exponent = {};

  if(base >= 2 && base <= 36){
    success = nExtractPartsFromNumberString(string, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessage);
    if(success){
      numberReference.numberValue = nCreateNumberFromParts(base, numberIsPositive.booleanValue, beforePoint.numberArray, afterPoint.numberArray, exponentIsPositive.booleanValue, exponent.numberArray);
    }
  }else{
    success = false;
    errorMessage.string = "Base must be from 2 to 36.".split('');
  }

  return success;
}
function nCreateNumberFromParts(base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent){
  var n, i, p, e;
  n = 0;

  for(i = 0; i < beforePoint.length; i = i + 1){
    p = beforePoint[beforePoint.length - i - 1];
    n = n + p*Math.pow(base, i);
  }

  for(i = 0; i < afterPoint.length; i = i + 1){
    p = afterPoint[i];
    n = n + p*Math.pow(base,  -(i + 1));
  }

  if(exponent.length > 0){
    e = 0;
    for(i = 0; i < exponent.length; i = i + 1){
      p = exponent[exponent.length - i - 1];
      e = e + p*Math.pow(base, i);
    }
    if( !exponentIsPositive ){
      e =  -e;
    }
    n = n*Math.pow(base, e);
  }

  if( !numberIsPositive ){
    n =  -n;
  }

  return n;
}
function nExtractPartsFromNumberString(n, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var i;
  var success;
  i = 0;

  if(i < n.length){
    if(n[i] == '-'){
      numberIsPositive.booleanValue = false;
      i = i + 1;
    }else if(n[i] == '+'){
      numberIsPositive.booleanValue = true;
      i = i + 1;
    }
    success = nExtractPartsFromNumberStringFromSign(n, base, i, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages);
  }else{
    success = false;
    errorMessages.string = "Number cannot have length zero.".split('');
  }

  return success;
}
function nExtractPartsFromNumberStringFromSign(n, base, i, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;
  done = false;
  count = 0;
  for(; i + count < n.length &&  !done ; ){
    if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
      count = count + 1;
    }else{
      done = true;
    }
  }

  if(count >= 1){
    beforePoint.numberArray = [];
    beforePoint.numberArray.length = count;
    for(j = 0; j < count; j = j + 1){
      beforePoint.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
    }
    i = i + count;
    if(i < n.length){
      success = nExtractPartsFromNumberStringFromPointOrExponent(n, base, i, afterPoint, exponentIsPositive, exponent, errorMessages);
    }else{
      afterPoint.numberArray = [];
      afterPoint.numberArray.length = 0;
      exponent.numberArray = [];
      exponent.numberArray.length = 0;
      success = true;
    }
  }else{
    success = false;
    errorMessages.string = "Number must have at least one number after the optional sign.".split('');
  }

  return success;
}
function nExtractPartsFromNumberStringFromPointOrExponent(n, base, i, afterPoint, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;
  if(n[i] == '.'){
    i = i + 1;
    if(i < n.length){
      done = false;
      count = 0;
      for(; i + count < n.length &&  !done ; ){
        if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
          count = count + 1;
        }else{
          done = true;
        }
      }
      if(count >= 1){
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = count;
        for(j = 0; j < count; j = j + 1){
          afterPoint.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
        }
        i = i + count;
        if(i < n.length){
          success = nExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages);
        }else{
          exponent.numberArray = [];
          exponent.numberArray.length = 0;
          success = true;
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the decimal point.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the decimal point.".split('');
    }
  }else if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
    if(i < n.length){
      success = nExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages);
      afterPoint.numberArray = [];
      afterPoint.numberArray.length = 0;
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the exponent.".split('');
    }
  }else{
    success = false;
    errorMessages.string = "Expected decimal point or exponent symbol.".split('');
  }

  return success;
}
function nExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;
  if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
    i = i + 1;
    if(i < n.length){
      if(n[i] == '-'){
        exponentIsPositive.booleanValue = false;
        i = i + 1;
      }else if(n[i] == '+'){
        exponentIsPositive.booleanValue = true;
        i = i + 1;
      }
      if(i < n.length){
        done = false;
        count = 0;
        for(; i + count < n.length &&  !done ; ){
          if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
            count = count + 1;
          }else{
            done = true;
          }
        }
        if(count >= 1){
          exponent.numberArray = [];
          exponent.numberArray.length = count;
          for(j = 0; j < count; j = j + 1){
            exponent.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
          }
          i = i + count;
          if(i == n.length){
            success = true;
          }else{
            success = false;
            errorMessages.string = "There cannot be any characters past the exponent of the number.".split('');
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the decimal point.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
    }
  }else{
    success = false;
    errorMessages.string = "Expected exponent symbol.".split('');
  }

  return success;
}
function nGetNumberFromNumberCharacterForBase(c, base){
  var numberTable;
  var i;
  var position;
  numberTable = nGetDigitCharacterTable();
  position = 0;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      position = i;
    }
  }

  return position;
}
function nCharacterIsNumberCharacterInBase(c, base){
  var numberTable;
  var i;
  var found;
  numberTable = nGetDigitCharacterTable();
  found = false;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      found = true;
    }
  }

  return found;
}
function nStringToNumberArray(str){
  var numberArrayReference;
  var stringReference;
  var numbers;
  numberArrayReference = {};
  stringReference = {};

  nStringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

  numbers = numberArrayReference.numberArray;

  delete(numberArrayReference);
  delete(stringReference);

  return numbers;
}
function nStringToNumberArrayWithCheck(str, numberArrayReference, errorMessage){
  var numberStrings;
  var numbers;
  var i;
  var numberString, trimmedNumberString;
  var success;
  var numberReference;
  numberStrings = SplitByString(str, ",".split(''));

  numbers = [];
  numbers.length = numberStrings.length;
  success = true;
  numberReference = {};

  for(i = 0; i < numberStrings.length; i = i + 1){
    numberString = numberStrings[i].string;
    trimmedNumberString = Trim(numberString);
    success = nCreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
    numbers[i] = numberReference.numberValue;
    FreeStringReference(numberStrings[i]);
    delete(trimmedNumberString);
  }

  delete(numberStrings);
  delete(numberReference);

  numberArrayReference.numberArray = numbers;

  return success;
}
function arraysStringToNumberArray(string){
  var i;
  var array;
  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function arraysNumberArrayToString(array){
  var i;
  var string;
  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function arraysNumberArraysEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysBooleanArraysEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysStringsEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysFillNumberArray(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillString(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillBooleanArray(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillNumberArrayInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = from; i < to; i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillBooleanArrayInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = Math.max(from, 0); i < Math.min(to, a.length); i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillStringInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = Math.max(from, 0); i < Math.min(to, a.length); i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyNumberArray(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyBooleanArray(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyString(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysIsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function arraysCreateNumberArray(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  arraysFillNumberArray(array, value);

  return array;
}
function arraysCreateBooleanArray(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  arraysFillBooleanArray(array, value);

  return array;
}
function arraysCreateString(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  arraysFillString(array, value);

  return array;
}
function LuhnCheck(number, errorMessage){
  var isValid;
  var numberReference;
  var checkDigitReference;
  var numberString;
  var digitReference;

  numberReference = {};
  checkDigitReference = {};
  numberString = [];
  numberString.length = 1;
  digitReference = {};

  isValid = arraysCopyStringRange(number, 0, number.length - 1, numberReference);
  if(isValid){
    isValid = LuhnComputeCheckDigit(numberReference.string, checkDigitReference, errorMessage);
    if(isValid){
      if(checkDigitReference.characterValue == number[number.length - 1]){
      }else{
        numberString[0] = number[number.length - 1];
        isValid = nCreateNumberFromDecimalStringWithCheck(numberString, digitReference, errorMessage);
        if(isValid){
          errorMessage.string = "Check digit wrong.".split('');
        }else{
          errorMessage.string = "Check symbol not a digit.".split('');
        }
        isValid = false;
      }
    }
  }else{
    errorMessage.string = "Number is too short: must be at least one digit.".split('');
  }

  return isValid;
}
function LuhnComputeCheckDigit(number, checkDigitReference, errorMessage){
  var sum, n, i, check;
  var alternate, isValid;
  var numberReference;
  var numberString;

  sum = 0;
  alternate = true;
  numberString = [];
  numberString.length = 1;
  numberReference = {};
  isValid = true;

  for(i = number.length - 1; i >= 0 && isValid; i = i - 1){
    numberString[0] = number[i];
    isValid = nCreateNumberFromDecimalStringWithCheck(numberString, numberReference, errorMessage);
    if(isValid){
      n = numberReference.numberValue;
      if(alternate){
        n = n*2;
        if(n > 9){
          n = (n%10) + 1;
        }
      }
      sum = sum + n;
      alternate =  !alternate ;
    }else{
      errorMessage.string = "Invalid digit in number string.".split('');
    }
  }

  if(isValid){
    check = sum%10;

    if(check != 0){
      check = 10 - check;
    }

    nGetSingleDigitCharacterFromNumberWithCheck(check, 10, checkDigitReference);
  }

  return isValid;
}
function LuhnExtendWithCheckDigit(number, extended, errorMessage){
  var isValid;
  var i;
  var checkDigitReference;

  checkDigitReference = {};
  isValid = LuhnComputeCheckDigit(number, checkDigitReference, errorMessage);

  if(isValid){
    extended.string = [];
    extended.string.length = number.length + 1;
    for(i = 0; i < number.length; i = i + 1){
      extended.string[i] = number[i];
    }
    extended.string[i] = checkDigitReference.characterValue;
  }

  return isValid;
}
function charToLowerCase(character){
  var toReturn;
  toReturn = character;
  if(character == 'A'){
    toReturn = 'a';
  }else if(character == 'B'){
    toReturn = 'b';
  }else if(character == 'C'){
    toReturn = 'c';
  }else if(character == 'D'){
    toReturn = 'd';
  }else if(character == 'E'){
    toReturn = 'e';
  }else if(character == 'F'){
    toReturn = 'f';
  }else if(character == 'G'){
    toReturn = 'g';
  }else if(character == 'H'){
    toReturn = 'h';
  }else if(character == 'I'){
    toReturn = 'i';
  }else if(character == 'J'){
    toReturn = 'j';
  }else if(character == 'K'){
    toReturn = 'k';
  }else if(character == 'L'){
    toReturn = 'l';
  }else if(character == 'M'){
    toReturn = 'm';
  }else if(character == 'N'){
    toReturn = 'n';
  }else if(character == 'O'){
    toReturn = 'o';
  }else if(character == 'P'){
    toReturn = 'p';
  }else if(character == 'Q'){
    toReturn = 'q';
  }else if(character == 'R'){
    toReturn = 'r';
  }else if(character == 'S'){
    toReturn = 's';
  }else if(character == 'T'){
    toReturn = 't';
  }else if(character == 'U'){
    toReturn = 'u';
  }else if(character == 'V'){
    toReturn = 'v';
  }else if(character == 'W'){
    toReturn = 'w';
  }else if(character == 'X'){
    toReturn = 'x';
  }else if(character == 'Y'){
    toReturn = 'y';
  }else if(character == 'Z'){
    toReturn = 'z';
  }

  return toReturn;
}
function charToUpperCase(character){
  var toReturn;
  toReturn = character;
  if(character == 'a'){
    toReturn = 'A';
  }else if(character == 'b'){
    toReturn = 'B';
  }else if(character == 'c'){
    toReturn = 'C';
  }else if(character == 'd'){
    toReturn = 'D';
  }else if(character == 'e'){
    toReturn = 'E';
  }else if(character == 'f'){
    toReturn = 'F';
  }else if(character == 'g'){
    toReturn = 'G';
  }else if(character == 'h'){
    toReturn = 'H';
  }else if(character == 'i'){
    toReturn = 'I';
  }else if(character == 'j'){
    toReturn = 'J';
  }else if(character == 'k'){
    toReturn = 'K';
  }else if(character == 'l'){
    toReturn = 'L';
  }else if(character == 'm'){
    toReturn = 'M';
  }else if(character == 'n'){
    toReturn = 'N';
  }else if(character == 'o'){
    toReturn = 'O';
  }else if(character == 'p'){
    toReturn = 'P';
  }else if(character == 'q'){
    toReturn = 'Q';
  }else if(character == 'r'){
    toReturn = 'R';
  }else if(character == 's'){
    toReturn = 'S';
  }else if(character == 't'){
    toReturn = 'T';
  }else if(character == 'u'){
    toReturn = 'U';
  }else if(character == 'v'){
    toReturn = 'V';
  }else if(character == 'w'){
    toReturn = 'W';
  }else if(character == 'x'){
    toReturn = 'X';
  }else if(character == 'y'){
    toReturn = 'Y';
  }else if(character == 'z'){
    toReturn = 'Z';
  }

  return toReturn;
}
function charIsUpperCase(character){
  var isUpper;
  isUpper = false;
  if(character == 'A'){
    isUpper = true;
  }else if(character == 'B'){
    isUpper = true;
  }else if(character == 'C'){
    isUpper = true;
  }else if(character == 'D'){
    isUpper = true;
  }else if(character == 'E'){
    isUpper = true;
  }else if(character == 'F'){
    isUpper = true;
  }else if(character == 'G'){
    isUpper = true;
  }else if(character == 'H'){
    isUpper = true;
  }else if(character == 'I'){
    isUpper = true;
  }else if(character == 'J'){
    isUpper = true;
  }else if(character == 'K'){
    isUpper = true;
  }else if(character == 'L'){
    isUpper = true;
  }else if(character == 'M'){
    isUpper = true;
  }else if(character == 'N'){
    isUpper = true;
  }else if(character == 'O'){
    isUpper = true;
  }else if(character == 'P'){
    isUpper = true;
  }else if(character == 'Q'){
    isUpper = true;
  }else if(character == 'R'){
    isUpper = true;
  }else if(character == 'S'){
    isUpper = true;
  }else if(character == 'T'){
    isUpper = true;
  }else if(character == 'U'){
    isUpper = true;
  }else if(character == 'V'){
    isUpper = true;
  }else if(character == 'W'){
    isUpper = true;
  }else if(character == 'X'){
    isUpper = true;
  }else if(character == 'Y'){
    isUpper = true;
  }else if(character == 'Z'){
    isUpper = true;
  }

  return isUpper;
}
function charIsLowerCase(character){
  var isLower;
  isLower = false;
  if(character == 'a'){
    isLower = true;
  }else if(character == 'b'){
    isLower = true;
  }else if(character == 'c'){
    isLower = true;
  }else if(character == 'd'){
    isLower = true;
  }else if(character == 'e'){
    isLower = true;
  }else if(character == 'f'){
    isLower = true;
  }else if(character == 'g'){
    isLower = true;
  }else if(character == 'h'){
    isLower = true;
  }else if(character == 'i'){
    isLower = true;
  }else if(character == 'j'){
    isLower = true;
  }else if(character == 'k'){
    isLower = true;
  }else if(character == 'l'){
    isLower = true;
  }else if(character == 'm'){
    isLower = true;
  }else if(character == 'n'){
    isLower = true;
  }else if(character == 'o'){
    isLower = true;
  }else if(character == 'p'){
    isLower = true;
  }else if(character == 'q'){
    isLower = true;
  }else if(character == 'r'){
    isLower = true;
  }else if(character == 's'){
    isLower = true;
  }else if(character == 't'){
    isLower = true;
  }else if(character == 'u'){
    isLower = true;
  }else if(character == 'v'){
    isLower = true;
  }else if(character == 'w'){
    isLower = true;
  }else if(character == 'x'){
    isLower = true;
  }else if(character == 'y'){
    isLower = true;
  }else if(character == 'z'){
    isLower = true;
  }

  return isLower;
}
function charIsLetter(character){
  return charIsUpperCase(character) || charIsLowerCase(character);
}
function charIsNumber(character){
  var isNumber;
  isNumber = false;
  if(character == '0'){
    isNumber = true;
  }else if(character == '1'){
    isNumber = true;
  }else if(character == '2'){
    isNumber = true;
  }else if(character == '3'){
    isNumber = true;
  }else if(character == '4'){
    isNumber = true;
  }else if(character == '5'){
    isNumber = true;
  }else if(character == '6'){
    isNumber = true;
  }else if(character == '7'){
    isNumber = true;
  }else if(character == '8'){
    isNumber = true;
  }else if(character == '9'){
    isNumber = true;
  }

  return isNumber;
}
function charIsWhiteSpace(character){
  var isWhiteSpace;
  isWhiteSpace = false;
  if(character == ' '){
    isWhiteSpace = true;
  }else if(character == '\t'){
    isWhiteSpace = true;
  }else if(character == '\n'){
    isWhiteSpace = true;
  }else if(character == '\r'){
    isWhiteSpace = true;
  }

  return isWhiteSpace;
}
function charIsSymbol(character){
  var isSymbol;
  isSymbol = false;
  if(character == '!'){
    isSymbol = true;
  }else if(character == '\"'){
    isSymbol = true;
  }else if(character == '#'){
    isSymbol = true;
  }else if(character == '$'){
    isSymbol = true;
  }else if(character == '%'){
    isSymbol = true;
  }else if(character == '&'){
    isSymbol = true;
  }else if(character == '\''){
    isSymbol = true;
  }else if(character == '('){
    isSymbol = true;
  }else if(character == ')'){
    isSymbol = true;
  }else if(character == '*'){
    isSymbol = true;
  }else if(character == '+'){
    isSymbol = true;
  }else if(character == ','){
    isSymbol = true;
  }else if(character == '-'){
    isSymbol = true;
  }else if(character == '.'){
    isSymbol = true;
  }else if(character == '/'){
    isSymbol = true;
  }else if(character == ':'){
    isSymbol = true;
  }else if(character == ';'){
    isSymbol = true;
  }else if(character == '<'){
    isSymbol = true;
  }else if(character == '='){
    isSymbol = true;
  }else if(character == '>'){
    isSymbol = true;
  }else if(character == '?'){
    isSymbol = true;
  }else if(character == '@'){
    isSymbol = true;
  }else if(character == '['){
    isSymbol = true;
  }else if(character == '\\'){
    isSymbol = true;
  }else if(character == ']'){
    isSymbol = true;
  }else if(character == '^'){
    isSymbol = true;
  }else if(character == '_'){
    isSymbol = true;
  }else if(character == '`'){
    isSymbol = true;
  }else if(character == '{'){
    isSymbol = true;
  }else if(character == '|'){
    isSymbol = true;
  }else if(character == '}'){
    isSymbol = true;
  }else if(character == '~'){
    isSymbol = true;
  }

  return isSymbol;
}
function CreateBooleanReference(value){
  var ref;
  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;
  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;
  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;
  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;
  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;
  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;
  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;
  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !arraysStringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function SubstringWithCheck(string, from, to, stringReference){
  var success;
  if(from < string.length && to < string.length && from <= to && from >= 0 && to >= 0){
    stringReference.string = Substring(string, from, to);
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Substring(string, from, to){
  var n;
  var i;
  n = [];
  n.length = Math.max(to - from, 0);

  for(i = from; i < to; i = i + 1){
    n[i - from] = string[i];
  }

  return n;
}
function AppendString(string, s){
  var newString;
  newString = ConcatenateString(string, s);

  delete(string);

  return newString;
}
function ConcatenateString(string, s){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + s.length;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  for(i = 0; i < s.length; i = i + 1){
    newString[string.length + i] = s[i];
  }

  return newString;
}
function AppendCharacter(string, c){
  var newString;
  newString = ConcatenateCharacter(string, c);

  delete(string);

  return newString;
}
function ConcatenateCharacter(string, c){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + 1;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  newString[string.length] = c;

  return newString;
}
function SplitByCharacter(toSplit, splitBy){
  var split;
  var stringToSplitBy;
  stringToSplitBy = [];
  stringToSplitBy.length = 1;
  stringToSplitBy[0] = splitBy;

  split = SplitByString(toSplit, stringToSplitBy);

  delete(stringToSplitBy);

  return split;
}
function IndexOfCharacter(string, character, indexReference){
  var i;
  var found;
  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function SubstringEqualsWithCheck(string, from, substring, equalsReference){
  var success;
  if(from < string.length){
    success = true;
    equalsReference.booleanValue = SubstringEquals(string, from, substring);
  }else{
    success = false;
  }

  return success;
}
function SubstringEquals(string, from, substring){
  var i;
  var equal;
  equal = true;
  for(i = 0; i < substring.length && equal; i = i + 1){
    if(string[from + i] != substring[i]){
      equal = false;
    }
  }

  return equal;
}
function IndexOfString(string, substring, indexReference){
  var i;
  var found;
  found = false;
  for(i = 0; i < string.length - substring.length + 1 &&  !found ; i = i + 1){
    if(SubstringEquals(string, i, substring)){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function ContainsCharacter(string, character){
  return IndexOfCharacter(string, character, {});
}
function ContainsString(string, substring){
  return IndexOfString(string, substring, {});
}
function ToUpperCase(string){
  var i;
  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToUpperCase(string[i]);
  }
}
function ToLowerCase(string){
  var i;
  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToLowerCase(string[i]);
  }
}
function EqualsIgnoreCase(a, b){
  var equal;
  var i;
  if(a.length == b.length){
    equal = true;
    for(i = 0; i < a.length && equal; i = i + 1){
      if(charToLowerCase(a[i]) != charToLowerCase(b[i])){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function ReplacesString(string, toReplace, replaceWith){
  var result;
  var i;
  var equalsReference;
  var success;
  equalsReference = {};
  result = [];
  result.length = 0;

  for(i = 0; i < string.length; ){
    success = SubstringEqualsWithCheck(string, i, toReplace, equalsReference);
    if(success){
      success = equalsReference.booleanValue;
    }
    if(success && toReplace.length > 0){
      result = ConcatenateString(result, replaceWith);
      i = i + toReplace.length;
    }else{
      result = ConcatenateCharacter(result, string[i]);
      i = i + 1;
    }
  }

  return result;
}
function ReplaceCharacter(string, toReplace, replaceWith){
  var result;
  var i;
  result = [];
  result.length = 0;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      result = ConcatenateCharacter(result, replaceWith);
    }else{
      result = ConcatenateCharacter(result, string[i]);
    }
  }

  return result;
}
function Trim(string){
  var result;
  var i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
  var firstNonWhitespaceFound;
  lastWhitespaceLocationStart =  -1;
  firstNonWhitespaceFound = false;
  for(i = 0; i < string.length &&  !firstNonWhitespaceFound ; i = i + 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationStart = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  /* Find whitepaces at the end. */
  lastWhitespaceLocationEnd = string.length;
  firstNonWhitespaceFound = false;
  for(i = string.length - 1; i >= 0 &&  !firstNonWhitespaceFound ; i = i - 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationEnd = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
    result = Substring(string, lastWhitespaceLocationStart + 1, lastWhitespaceLocationEnd);
  }else{
    result = [];
    result.length = 0;
  }

  return result;
}
function StartsWith(string, start){
  var startsWithString;
  startsWithString = false;
  if(string.length >= start.length){
    startsWithString = SubstringEquals(string, 0, start);
  }

  return startsWithString;
}
function EndsWith(string, end){
  var endsWithString;
  endsWithString = false;
  if(string.length >= end.length){
    endsWithString = SubstringEquals(string, string.length - end.length, end);
  }

  return endsWithString;
}
function SplitByString(toSplit, splitBy){
  var split;
  var next;
  var i;
  var c;
  var n;
  split = [];
  split.length = 0;

  next = [];
  next.length = 0;
  for(i = 0; i < toSplit.length; ){
    c = toSplit[i];
    if(SubstringEquals(toSplit, i, splitBy)){
      if(split.length != 0 || i != 0){
        n = {};
        n.string = next;
        split = AddString(split, n);
        next = [];
        next.length = 0;
        i = i + splitBy.length;
      }
    }else{
      next = AppendCharacter(next, c);
      i = i + 1;
    }
  }

  if(next.length > 0){
    n = {};
    n.string = next;
    split = AddString(split, n);
  }

  return split;
}
function Negate(x){
  return  -x;
}
function Positive(x){
  return  +x;
}
function Factorial(x){
  var i, f;
  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function Round(x){
  return Math.floor(x + 0.5);
}
function BankersRound(x){
  var r;
  if(Absolute(x - Truncate(x)) == 0.5){
    if( !DivisibleBy(Round(x), 2) ){
      r = Round(x) - 1;
    }else{
      r = Round(x);
    }
  }else{
    r = Round(x);
  }

  return r;
}
function Ceil(x){
  return Math.ceil(x);
}
function Floor(x){
  return Math.floor(x);
}
function Truncate(x){
  var t;
  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function Absolute(x){
  return Math.abs(x);
}
function Logarithm(x){
  return Math.log10(x);
}
function NaturalLogarithm(x){
  return Math.log(x);
}
function Sin(x){
  return Math.sin(x);
}
function Cos(x){
  return Math.cos(x);
}
function Tan(x){
  return Math.tan(x);
}
function Asin(x){
  return Math.asin(x);
}
function Acos(x){
  return Math.acos(x);
}
function Atan(x){
  return Math.atan(x);
}
function Atan2(y, x){
  var a;
  a = 0;

  if(x > 0){
    a = Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function Squareroot(x){
  return Math.sqrt(x);
}
function Exp(x){
  return Math.exp(x);
}
function DivisibleBy(a, b){
  return ((a%b) == 0);
}
function Combinations(n, k){
  return Factorial(n)/(Factorial(n - k)*Factorial(k));
}
function EpsilonCompareApproximateDigits(a, b, digits){
  var ad, bd, d, epsilon;
  var ret;
  if(a < 0 && b < 0 || a > 0 && b > 0){
    if(a < 0 && b < 0){
      a =  -a;
      b =  -b;
    }
    ad = Math.log10(a);
    bd = Math.log10(b);
    d = Math.max(ad, bd);
    epsilon = Math.pow(10, d - digits);
    ret = Math.abs(a - b) > epsilon;
  }else{
    ret = false;
  }

  return ret;
}
function EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function GreatestCommonDivisor(a, b){
  var t;
  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;
  if(IsInteger(a) && IsInteger(b)){
    gcd = GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultiple(a, b){
  var lcm;
  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function Sign(a){
  var s;
  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function Max(a, b){
  return Math.max(a, b);
}
function Min(a, b){
  return Math.min(a, b);
}
function Power(a, b){
  return Math.pow(a, b);
}
function AddNumber(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function AddBoolean(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function AddCharacter(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }

  delete(list);

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}


module.exports = {
	ISINCheck: ISINCheck,
	ISINComputeCheckDigit: ISINComputeCheckDigit,
	ISINExtendWithCheckDigit: ISINExtendWithCheckDigit,
	ISINToNumericCode: ISINToNumericCode,
	ISINSymbolToCode: ISINSymbolToCode,
	nCreateStringScientificNotationDecimalFromNumber: nCreateStringScientificNotationDecimalFromNumber,
	nCreateStringDecimalFromNumber: nCreateStringDecimalFromNumber,
	nCreateStringFromNumberWithCheck: nCreateStringFromNumberWithCheck,
	nGetMaximumDigitsForBase: nGetMaximumDigitsForBase,
	nGetFirstDigitPosition: nGetFirstDigitPosition,
	nGetSingleDigitCharacterFromNumberWithCheck: nGetSingleDigitCharacterFromNumberWithCheck,
	nGetDigitCharacterTable: nGetDigitCharacterTable,
	nCreateNumberFromDecimalStringWithCheck: nCreateNumberFromDecimalStringWithCheck,
	nCreateNumberFromDecimalString: nCreateNumberFromDecimalString,
	nCreateNumberFromStringWithCheck: nCreateNumberFromStringWithCheck,
	nCreateNumberFromParts: nCreateNumberFromParts,
	nExtractPartsFromNumberString: nExtractPartsFromNumberString,
	nExtractPartsFromNumberStringFromSign: nExtractPartsFromNumberStringFromSign,
	nExtractPartsFromNumberStringFromPointOrExponent: nExtractPartsFromNumberStringFromPointOrExponent,
	nExtractPartsFromNumberStringFromExponent: nExtractPartsFromNumberStringFromExponent,
	nGetNumberFromNumberCharacterForBase: nGetNumberFromNumberCharacterForBase,
	nCharacterIsNumberCharacterInBase: nCharacterIsNumberCharacterInBase,
	nStringToNumberArray: nStringToNumberArray,
	nStringToNumberArrayWithCheck: nStringToNumberArrayWithCheck,
	arraysStringToNumberArray: arraysStringToNumberArray,
	arraysNumberArrayToString: arraysNumberArrayToString,
	arraysNumberArraysEqual: arraysNumberArraysEqual,
	arraysBooleanArraysEqual: arraysBooleanArraysEqual,
	arraysStringsEqual: arraysStringsEqual,
	arraysFillNumberArray: arraysFillNumberArray,
	arraysFillString: arraysFillString,
	arraysFillBooleanArray: arraysFillBooleanArray,
	arraysFillNumberArrayInterval: arraysFillNumberArrayInterval,
	arraysFillBooleanArrayInterval: arraysFillBooleanArrayInterval,
	arraysFillStringInterval: arraysFillStringInterval,
	arraysCopyNumberArray: arraysCopyNumberArray,
	arraysCopyBooleanArray: arraysCopyBooleanArray,
	arraysCopyString: arraysCopyString,
	arraysCopyNumberArrayRange: arraysCopyNumberArrayRange,
	arraysCopyBooleanArrayRange: arraysCopyBooleanArrayRange,
	arraysCopyStringRange: arraysCopyStringRange,
	arraysIsLastElement: arraysIsLastElement,
	arraysCreateNumberArray: arraysCreateNumberArray,
	arraysCreateBooleanArray: arraysCreateBooleanArray,
	arraysCreateString: arraysCreateString,
	LuhnCheck: LuhnCheck,
	LuhnComputeCheckDigit: LuhnComputeCheckDigit,
	LuhnExtendWithCheckDigit: LuhnExtendWithCheckDigit,
	charToLowerCase: charToLowerCase,
	charToUpperCase: charToUpperCase,
	charIsUpperCase: charIsUpperCase,
	charIsLowerCase: charIsLowerCase,
	charIsLetter: charIsLetter,
	charIsNumber: charIsNumber,
	charIsWhiteSpace: charIsWhiteSpace,
	charIsSymbol: charIsSymbol,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	SubstringWithCheck: SubstringWithCheck,
	Substring: Substring,
	AppendString: AppendString,
	ConcatenateString: ConcatenateString,
	AppendCharacter: AppendCharacter,
	ConcatenateCharacter: ConcatenateCharacter,
	SplitByCharacter: SplitByCharacter,
	IndexOfCharacter: IndexOfCharacter,
	SubstringEqualsWithCheck: SubstringEqualsWithCheck,
	SubstringEquals: SubstringEquals,
	IndexOfString: IndexOfString,
	ContainsCharacter: ContainsCharacter,
	ContainsString: ContainsString,
	ToUpperCase: ToUpperCase,
	ToLowerCase: ToLowerCase,
	EqualsIgnoreCase: EqualsIgnoreCase,
	ReplacesString: ReplacesString,
	ReplaceCharacter: ReplaceCharacter,
	Trim: Trim,
	StartsWith: StartsWith,
	EndsWith: EndsWith,
	SplitByString: SplitByString,
	Negate: Negate,
	Positive: Positive,
	Factorial: Factorial,
	Round: Round,
	BankersRound: BankersRound,
	Ceil: Ceil,
	Floor: Floor,
	Truncate: Truncate,
	Absolute: Absolute,
	Logarithm: Logarithm,
	NaturalLogarithm: NaturalLogarithm,
	Sin: Sin,
	Cos: Cos,
	Tan: Tan,
	Asin: Asin,
	Acos: Acos,
	Atan: Atan,
	Atan2: Atan2,
	Squareroot: Squareroot,
	Exp: Exp,
	DivisibleBy: DivisibleBy,
	Combinations: Combinations,
	EpsilonCompareApproximateDigits: EpsilonCompareApproximateDigits,
	EpsilonCompare: EpsilonCompare,
	GreatestCommonDivisor: GreatestCommonDivisor,
	IsInteger: IsInteger,
	GreatestCommonDivisorWithCheck: GreatestCommonDivisorWithCheck,
	LeastCommonMultiple: LeastCommonMultiple,
	Sign: Sign,
	Max: Max,
	Min: Min,
	Power: Power,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	test: test
};